package com.miya.manning.framework.util;

import com.miya.manning.enums.ScriptType;
import com.miya.manning.vo.*;
import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import java.lang.reflect.Method;
import java.util.List;
import java.util.stream.Collectors;

public class ScriptUtil {
    private static final Logger log = Logger.getLogger(ScriptUtil.class);

    public static void ExcuteScript(List<Script> scriptList , TestCase testCase ) throws Exception {
        ExcuteableScript script = null;
        ApplicationContext ac = new ClassPathXmlApplicationContext("ApplicationContext.xml");
        ScriptFactory scriptFactory = (ScriptFactory) ac.getBean("ScriptFactory");
        List<Script> list_script =scriptList.stream().filter(x -> x.getScript_name().equals(testCase.getScript_name())).collect(Collectors.toList());
        if(list_script.size() == 0) {
            throw new Exception("没有匹配到脚本！");
        }if(list_script.size() >1 ){
            throw new Exception("匹配到多个同名脚本！");
        }else{
            Class<?> clz = Class.forName("com.miya.manning.vo.ScriptFactory");
            Script sc = list_script.get(0);
            Method method =  clz.getDeclaredMethod("create" + sc.getSrcipt_type() + "Script",String.class);
            if(ScriptType.JAVA_SCRIPT.getType().equals(sc.getSrcipt_type())){
                script = (JavaScript) method.invoke(scriptFactory,sc.getScript_param());
                log.info("开始执行脚本：" + sc.getScript_name());
                script.excute(sc.getScript_param());
            }
            if(ScriptType.SSH_SCRIPT.getType().equals(sc.getSrcipt_type())){
                script = (SSHScript) method.invoke(scriptFactory,sc.getScript_param());
                log.info("开始执行脚本：" + sc.getScript_name());
                script.excute(sc.getScript_param());
            }

        }
    }
}
